<?php

use Monolog\Logger;
use Psr\Log\LoggerInterface;

class LoggerRegistry
{
    private $_loggers = [];

    public function pushLogger(Logger $logger): LoggerRegistry
    {
        if(!array_key_exists($logger->getName(), $this->_loggers)){
            $this->_loggers[$logger->getName()] = $logger;
        }
        return $this;
    }

    public function getLogger($name): LoggerInterface
    {
        if(!array_key_exists($name, $this->_loggers)) {
            throw new LogicException('Logger does not exists');
        }
        return $this->_loggers[$name];
    }
}