<?php

/**
 * Class Taxe
 */
class Taxe extends Model {

    /**
     * @var string
     */
    protected $table = 'taxe';

    /**
     * @param $prixTTC
     * @param $taxeId
     * @return mixed
     *
     * renvoie le prix HT avec un prix TTC et un taxe_id
     */
    public function getPrixHt($prixTTC, $taxeId)
    {
        $sql = "SELECT ('" . $prixTTC . "' /(1 + taxe_taux)) AS prix_ht FROM taxe WHERE taxe_id = '" . $taxeId . "'";
        $result = $this->sql->getOne($sql);
        return $result['prix_ht'];
    }

    /**
     * @param $prixTTC
     * @param $taxeId
     * @return mixed
     *
     * renvoie le prix TTC avec un prix HT et un taxe_id
     */
    public function getPrixTtc($prixTTC, $taxeId)
    {
        $sql = "SELECT ('" . $prixTTC . "' *(1 + taxe_taux)) AS prix_ttc FROM taxe WHERE taxe_id = '" . $taxeId . "'";
        $result = $this->sql->getOne($sql);
        return $result['prix_ttc'];
    }

    /**
     * Change la taxe sur le site avec la taxe passé en parametre
     *
     * @param Taxe $newTaxe
     * @throws Exception
     */
    static public function migrate(Taxe $newTaxe)
    {
        $con = SiteSQL::getInstance();
        if (empty($tables)) {
            $con->query("SHOW TABLES", SiteSQL::SQL_ALL);
            $tables = $con->record;
        }

        $except = array('taxe');

        $field = 'taxe_id';
        $query = new Query();

        foreach ($tables as $t) {

            if (in_array($t[0], $except)) {
                continue;
            }

            $struct = $con->getStructure($t[0]);
            foreach ($struct as $stru) {
                if ($stru['Field'] == $field) {
                    $query->reset()->update($t[0])->value($field, $newTaxe->$field);
                    $con->query($query->build());
                }
            }
        }
    }
}