/**
 *
 * @constructor
 */
var Panier = function () {

};

/**
 * Function to add a product to the cart
 *
 * @param nForm
 */
Panier.prototype.add = function(nForm) {
    $.ajax({
        type: "POST",
        url: nForm.attr('action'),
        data:nForm.serialize(),
        dataType:'JSON',
        success: function(data) {
            var toToggle = nForm.attr('data-target');

            if (data.status == true) {
                $(toToggle + ' #myModalLabel').html(data.message);
                $(toToggle + ' .modal-footer').show();
                $('.headerLink.cart .count').html(data.countProduct);
            } else {
                $(toToggle + ' #myModalLabel').html(data.error);
                $(toToggle + ' .modal-footer').hide();
            }

            $(toToggle).modal('toggle');
        }
    });
    return true;
};


Panier.prototype.refreshDropCart = function(){
    $.ajax({
        type: "POST",
        url: "/cart/rollover",
        success: function (data) {
            jQuery('.main-header li.panier').html(data);
        }
    });
};

Panier.prototype.update = function(identifier, quantite) {
    if (quantite <= 0) {
        this.delete(identifier);
    } else {
        $.ajax({
            type: "POST",
            url: "/cart/update",
            dataType: 'json',
            data: 'action=update&identifier=' + identifier + '&quantite=' + quantite,
            success: function (data) {
                if (data.status) {
                    location.reload();
                }
            }
        });
    }
};

Panier.prototype.delete = function(identifier) {
    $.ajax({
        type: "POST",
        url: "/cart/delete",
        dataType: 'json',
        data: 'action=delete&identifier=' + identifier,
        success: function (data) {
            if (data.status) {
                location.reload();
            }
        }
    });
};

Panier.prototype.addAddress = function(addrType, nForm) {
    $.ajax({
        type: "POST",
        url: "/js/ajax/adresse.php",
        dataType: 'json',
        data: 'action=add&type='+addrType + '&' + nForm.serialize(),
        success: function (data) {
            if (data.status) {
                location.reload();
            } else {
                $('#error').html(data.message);
            }
        }
    });
};

Panier.prototype.changeAddress = function(addrType, id) {
    $.ajax({
        type: "POST",
        url: "/cart/address/change",
        dataType: 'json',
        data: 'type='+addrType+'&adresse_id=' + id,
        success: function (data) {
            if (data.status) {
                location.reload();
            }
        }
    });
};

Panier.prototype.selectShipping = function(id) {
    $.ajax({
        type: "POST",
        url: "/cart/shipping/select",
        dataType: 'json',
        data: 'action=change&livraison_id=' + id,
        success: function (data) {
            if (data.status) {
                if (data.data_bind) {
                    dataBind(data.data_bind);
                }

                /*if (data.relais || data.relais == '') {
                    if ($('#list-point-relais').length == 0) {
                        $('.tab_livraison_cp').append($('<div></div>').attr('id', 'list-point-relais'));
                    }
                    $('#list-point-relais').html(data.relais);
                }*/
            }
        }
    });
};

Panier.prototype.addReduction = function(reductionCode) {
    $.ajax({
        type: "POST",
        url: "/cart/reduction/add",
        dataType: 'json',
        data: 'promotion_code=' + reductionCode,
        success: function (data) {
            if (data.status) {
                location.reload();
            } else {
                jQuery('form[name="code-promo"]').find('.error').html(data.message);
            }
        }
    });
};

Panier.prototype.setSameAddress = function(sameAddress) {
    $.ajax({
        type: "POST",
        url: "/cart/same-address",
        dataType: 'json',
        data: 'same_address=' + sameAddress,
        success: function (data) {

        }
    });
};

Panier.prototype.addBonAchat = function(baId) {
    this.callAjax('/cart/voucher/add', {bon_achat_id: baId}, function(data){
        if (data.status) {location.reload();}
    });
};

Panier.prototype.deleteBonAchat = function(baId) {
    this.callAjax('/cart/voucher/delete', {bon_achat_id: baId}, function(data){
        if (data.status) {location.reload();}
    });
};

Panier.prototype.callAjax = function(url, data, callback) {
    $.ajax({
        type: "POST",
        url: url,
        dataType: 'json',
        data: data,
        success: function (data) {
            callback(data);
        }
    });
};

Panier.prototype.addFromHistory = function (nForm) {
    var toToggle = $('div#modalAddNews');
    $.ajax({
        type: "POST",
        url: $(nForm).attr('action'),
        dataType: 'json',
        data: $(nForm).serialize(),
        success: function (data) {
            if(data.status == true){
                var html = data.success;
                if(data.error != undefined){
                    data.error.forEach(function (element) {
                        html += "<br>" + element;
                    });
                }
                $('div#modalAddNewsLabel').html(html);
                $(toToggle).modal('toggle');
            } else {

            }
            $(toToggle).on('hidden.bs.modal', function () {
                location.reload();
            });
        }
    });
};